// CustomCookieSettingsDialog.cpp : implementation file
//

#include "stdafx.h"

#include "P3PClient.h"
#include "P3PObject.h"
#include "CustomCookieSettingsDialog.h"
#include "P3PPreferences.h"
#include "commctrl.h"
#include "Globals.h"



/////////////////////////////////////////////////////////////////////////////
// CCustomCookieSettingsDialog dialog

static DWORD help_array[] = {
							IDC_GROUP_CUSTOMCOOKIESETTINGS, IDH_GROUP_CUSTOMCOOKIESETTINGS,
							IDC_CUSTOMCOOKIE_ALL, IDH_CUSTOMCOOKIE_ALL,
							IDC_CUSTOMCOOKIE_NONE, IDH_CUSTOMCOOKIE_NONE,
							IDC_CUSTOMCOOKIE_MATCHING, IDH_CUSTOMCOOKIE_MATCHING,
							IDC_LASTPAGEVISITED_ALL, IDH_LASTPAGEVISITED_ALL,
							IDC_LASTPAGEVISITED_NONE, IDH_LASTPAGEVISITED_NONE,
							IDC_LASTPAGEVISITED_MATCHING, IDH_LASTPAGEVISITED_MATCHING,
							IDC_CROSSSITECOOKIE_ALL, IDH_CROSSSITECOOKIE_ALL,
							IDC_CROSSSITECOOKIE_NONE, IDH_CROSSSITECOOKIE_NONE,
							IDC_CROSSSITECOOKIE_MATCHING, IDH_CROSSSITECOOKIE_MATCHING,
							IDC_STATIC1, -1,
							0,0
						};




CCustomCookieSettingsDialog::CCustomCookieSettingsDialog() 
{
	// Store the pointer to the CP3PObject class
}


CCustomCookieSettingsDialog::~CCustomCookieSettingsDialog()
{
}


LRESULT CCustomCookieSettingsDialog::OnInitDialog(UINT uMsg, WPARAM wParam, 
	LPARAM lParam, BOOL& bHandled)
{

	switch (g_p3p_preferences.allow_cookies_custom)
	{
	case P3PPreferences::MATCHING_PREFERENCES :
		CheckDlgButton(IDC_CUSTOMCOOKIE_MATCHING, BST_CHECKED); break;

	case P3PPreferences::ALL :
		CheckDlgButton(IDC_CUSTOMCOOKIE_ALL, BST_CHECKED); break;

	case P3PPreferences::NONE :
		CheckDlgButton(IDC_CUSTOMCOOKIE_NONE, BST_CHECKED); break;

	}

	switch (g_p3p_preferences.allow_cookies_custom_lastpagevisited)
	{
	case P3PPreferences::MATCHING_PREFERENCES :
		CheckDlgButton(IDC_LASTPAGEVISITED_MATCHING, BST_CHECKED); break;

	case P3PPreferences::ALL :
		CheckDlgButton(IDC_LASTPAGEVISITED_ALL, BST_CHECKED); break;

	case P3PPreferences::NONE :
		CheckDlgButton(IDC_LASTPAGEVISITED_NONE, BST_CHECKED); break;

	}

	switch (g_p3p_preferences.allow_cookies_custom_crosssite)
	{
	case P3PPreferences::MATCHING_PREFERENCES :
		CheckDlgButton(IDC_CROSSSITECOOKIE_MATCHING, BST_CHECKED); break;

	case P3PPreferences::ALL :
		CheckDlgButton(IDC_CROSSSITECOOKIE_ALL, BST_CHECKED); break;

	case P3PPreferences::NONE :
		CheckDlgButton(IDC_CROSSSITECOOKIE_NONE, BST_CHECKED); break;

	}

	return 1;  
}


/////////////////////////////////////////////////////////////////////////////
// OnDestroy - Responds to the WM_DESTROY message
// 
LRESULT CCustomCookieSettingsDialog::OnDestroy(UINT, WPARAM, LPARAM, BOOL&)
{

	return 1;  
}


LRESULT CCustomCookieSettingsDialog::OnOK(WORD, WORD, HWND, BOOL&)
{

	if (IsDlgButtonChecked(IDC_CUSTOMCOOKIE_MATCHING) == BST_CHECKED)
	{
		g_p3p_preferences.allow_cookies_custom = P3PPreferences::MATCHING_PREFERENCES;
	}
	else if (IsDlgButtonChecked(IDC_CUSTOMCOOKIE_ALL) == BST_CHECKED)
	{
		g_p3p_preferences.allow_cookies_custom = P3PPreferences::ALL;
	} 
	else if (IsDlgButtonChecked(IDC_CUSTOMCOOKIE_NONE) == BST_CHECKED)
	{
		g_p3p_preferences.allow_cookies_custom = P3PPreferences::NONE;
	} 


	if (IsDlgButtonChecked(IDC_LASTPAGEVISITED_MATCHING) == BST_CHECKED)
	{
		g_p3p_preferences.allow_cookies_custom_lastpagevisited = P3PPreferences::MATCHING_PREFERENCES;
	}
	else if (IsDlgButtonChecked(IDC_LASTPAGEVISITED_ALL) == BST_CHECKED)
	{
		g_p3p_preferences.allow_cookies_custom_lastpagevisited = P3PPreferences::ALL;
	} 
	else if (IsDlgButtonChecked(IDC_LASTPAGEVISITED_NONE) == BST_CHECKED)
	{
		g_p3p_preferences.allow_cookies_custom_lastpagevisited = P3PPreferences::NONE;
	} 


	if (IsDlgButtonChecked(IDC_CROSSSITECOOKIE_MATCHING) == BST_CHECKED)
	{
		g_p3p_preferences.allow_cookies_custom_crosssite = P3PPreferences::MATCHING_PREFERENCES;
	}
	else if (IsDlgButtonChecked(IDC_CROSSSITECOOKIE_ALL) == BST_CHECKED)
	{
		g_p3p_preferences.allow_cookies_custom_crosssite = P3PPreferences::ALL;
	} 
	else if (IsDlgButtonChecked(IDC_CROSSSITECOOKIE_NONE) == BST_CHECKED)
	{
		g_p3p_preferences.allow_cookies_custom_crosssite = P3PPreferences::NONE;
	} 

	g_p3p_preferences.CookieSave(g_dllpath+COOKIE_FILE);

	EndDialog(IDOK);
	return 1;

}
LRESULT CCustomCookieSettingsDialog::OnCancel(WORD, WORD, HWND, BOOL&)
{
	EndDialog(IDCANCEL);
	return 1;

}

LRESULT CCustomCookieSettingsDialog::OnContextHelp(UINT id, WPARAM wParam, LPARAM lParam, BOOL& bFlag)
{

	HELPINFO* pHelpInfo = (LPHELPINFO) lParam;
	
	if (pHelpInfo->iContextType == HELPINFO_WINDOW)
	{
		return HtmlHelp( (HWND)pHelpInfo->hItemHandle, g_dllpath+"\\p3pclient.chm::/ContextSensitiveHelp.txt",
				HH_TP_HELP_WM_HELP, (DWORD)(LPVOID)help_array)  != NULL;
	}
	return 1;

}


LRESULT CCustomCookieSettingsDialog::OnHelp(WORD, WORD, HWND, BOOL&)
{
	return HtmlHelp( NULL, g_dllpath+"\\p3pclient.chm::/help-customcookiepreferences.html",
				HH_DISPLAY_TOPIC, 0)  != NULL;
	return 1;

}




