#ifndef __GLOBALS_H__
#define __GLOBALS_H__

#include <stddef.h>
#include <stdio.h>
#include "GString.h"
#include "arrays.h"
#include "GContainer.h"
#include "GURL.h"
#include "help_resources.h"
#include <time.h>

extern bool g_enabled;
extern bool g_onTitleBar;
extern POINT g_Position;
extern HINSTANCE hinst;
extern GString g_dllpath;

HWND AddToolTipToControl(HWND cntwnd, TCHAR *text);
void SetToolTipText(HWND tooltip, TCHAR *text);
GString AddReturns(const char*str);
bool read_file_data(const char* filename, const char* mode, DArray<char> &data);
int cvt_hotkey_mod(int hotkey_mod);

#define INITIALIZATION_FILE		"\\start.ini"
#define LOW_PREFERENCE_FILE		"\\appel-low.xml"
#define MEDIUM_PREFERENCE_FILE	"\\appel-medium.xml"
#define HIGH_PREFERENCE_FILE	"\\appel-high.xml"
#define PREFERENCE_FILE			"\\p3ppreferences.xml"
#define IMPORTED_PREFERENCE_FILE "\\appel-imported.xml"
#define COOKIE_FILE				"\\p3pcookiepreferences.xml"
#define BASE_SCHEMA_FILE		"\\BaseDataschema-std.xml"
#define NO_PROMPT_SITES_FILE	"\\NoPromptSites.p3p"
#define COOKIE_HISTORY_FILE		"\\CookieHistory.xml"
#define TUTORIAL_FILE			"\\Tutorial\\tour.html"


/* types */
typedef enum WIDE_CHAR_STANDARD_T {
    NO_WC_STANDARD,
    UTF8,
    UTF16LE,
    UTF16BE,
} WIDE_CHAR_STANDARD_T;


/* exported variables */
    extern WIDE_CHAR_STANDARD_T widechar;

/* functions */
    void *xmalloc(size_t n);
    void *xrealloc(void *s, size_t n);
    char *xstrdup(char *s);
    GString cvt_wc_to_utf8(unsigned long c);
    GString cvt_ws_to_utf8(const unsigned short *ws);

	int FileCopy(const char* file_in, const char* file_out);

	GURL GetURLFromP3PHeader(GString &p3pheader, const GURL &sourceURL);
	bool IsAllWhiteSpace(const char* str);
	void UnixTimeToSystemTime(time_t t, LPSYSTEMTIME pst);
	time_t SystemTimeToUnixTime( LPSYSTEMTIME pst);
	time_t InternetTimeToUnixTime(const char *it);
	GString tempfilename( GString &directory );

	void SendCommandToAllP3Ps(int command, bool all_windows=false);
	GString SeparateNameAndURL(GURL &url);

#endif