// OverrideSitesDialog.cpp : implementation file
//

#include "stdafx.h"

#include "P3PClient.h"
#include "P3PObject.h"
#include "OverrideSitesDialog.h"
#include "commctrl.h"
#include "Globals.h"
#include "URLListDialog.h"


/////////////////////////////////////////////////////////////////////////////
// COverrideSitesDialog dialog


COverrideSitesDialog::COverrideSitesDialog() 
{
}


COverrideSitesDialog::~COverrideSitesDialog()
{
}


LRESULT COverrideSitesDialog::OnInitDialog(UINT uMsg, WPARAM wParam, 
	LPARAM lParam, BOOL& bHandled)
{

	EnableButtons(false);

	HWND listhwnd=GetDlgItem(IDC_OVERRIDE_SITES_LIST);
	if( listhwnd )
	{
		ListView_SetExtendedListViewStyleEx(listhwnd, LVS_SHOWSELALWAYS|LVS_EX_FULLROWSELECT|LVS_EX_HEADERDRAGDROP , LVS_EX_FULLROWSELECT|LVS_EX_HEADERDRAGDROP );
		LVCOLUMN lvc;
			    
		lvc.mask = LVCF_FMT | LVCF_WIDTH | LVCF_TEXT | LVCF_SUBITEM; 
		lvc.fmt = LVCFMT_LEFT; 
		
		char *headerlabels[] = {"Web Site", "Cookie Preference"};
		int  column_sizes[] = {300, 200};

		for(int i=0; i<(sizeof(headerlabels)/sizeof(void*)); i++)
		{
			lvc.pszText = headerlabels[i];
			lvc.iSubItem = i; 
			lvc.cx = column_sizes[i];
			ListView_InsertColumn(listhwnd, i, &lvc);
		}

		LVITEM lvi;
				
		lvi.mask = LVIF_TEXT | LVIF_PARAM | LVIF_STATE;
		lvi.state = 0;     lvi.stateMask = 0; 
		
		int index = 0;
		for( GPosition pos = g_p3p_preferences.domain_prefs; pos; ++pos, index++ )
		{
			GString domian = g_p3p_preferences.domain_prefs.key(pos);
			P3PPreferences::site_allow_cookies pref = g_p3p_preferences.domain_prefs[pos];
			lvi.iItem = index;
			lvi.iSubItem = 0; 
			lvi.pszText = (char*)(const char *)domian;
			lvi.lParam = pref;
			int i = ListView_InsertItem(listhwnd, &lvi);

			GString resultstr;	

			switch( lvi.lParam )
			{
				case P3PPreferences::ALWAYS: resultstr = "Always allow";
					break;
				case P3PPreferences::THIS_SESSION: resultstr = "Allow for this session only";
					break;
				case P3PPreferences::NEVER: resultstr = "Never Allow";
					break;
				default : resultstr = "Unknown site_allow_cookies type, Bug some where";
					break;
			}

			///set type here
			ListView_SetItemText(listhwnd, i, 1, (char*)(const char *)resultstr);

		}

	}

	return 1;  
}


LRESULT COverrideSitesDialog::OnNotify(UINT code, WPARAM wParam, LPARAM lParam, BOOL& result)
{
	LPNMHDR pmhdr = (LPNMHDR) lParam;
	if( pmhdr->idFrom == IDC_OVERRIDE_SITES_LIST )
	{
		unsigned int i = ListView_GetSelectedCount(GetDlgItem(IDC_OVERRIDE_SITES_LIST));
		EnableButtons(i);
	}
	return FALSE;
}



/////////////////////////////////////////////////////////////////////////////
// OnDestroy - Responds to the WM_DESTROY message
// 
LRESULT COverrideSitesDialog::OnDestroy(UINT, WPARAM, LPARAM, BOOL&)
{

	return 1;  
}


LRESULT COverrideSitesDialog::OnDelete(WORD, WORD, HWND, BOOL&)
{
	HWND ListWnd=GetDlgItem(IDC_OVERRIDE_SITES_LIST);
	int i=ListView_GetNextItem(ListWnd, -1, LVNI_SELECTED);
	if( i >= 0 )
	{
		char buffer[2048];
		LVITEM lvi;
				
		lvi.mask = LVIF_TEXT | LVIF_PARAM | LVIF_STATE;
		lvi.state = 0;     lvi.stateMask = 0; 
		lvi.lParam=0;
		lvi.iItem = i;
		lvi.iSubItem = 0;
		lvi.pszText = buffer;
		lvi.cchTextMax = sizeof(buffer);

		if( ListView_GetItem(ListWnd, &lvi) )
		{
			return( ListView_DeleteItem(ListWnd, i) );
		}
	}

return FALSE;
}


LRESULT COverrideSitesDialog::OnOK(WORD, WORD, HWND, BOOL&)
{
	HWND ListWnd=GetDlgItem(IDC_OVERRIDE_SITES_LIST);
	int count=ListView_GetItemCount(ListWnd);
	if( count < g_p3p_preferences.domain_prefs.size() )  
	{
		g_p3p_preferences.domain_prefs.empty() ;

		char buffer[2048];
		LVITEM lvi;
					
		lvi.mask = LVIF_TEXT | LVIF_PARAM | LVIF_STATE;
		lvi.state = 0;     lvi.stateMask = 0; 
		lvi.lParam=0;

		lvi.iSubItem = 0;
		lvi.pszText = buffer;
		lvi.cchTextMax = sizeof(buffer);

		for(int i=0; i<count; i++)
		{
			lvi.iItem = i;  // index of the item to retrieve

			if( ListView_GetItem(ListWnd, &lvi) )
			{
				GString domain = buffer; 
				g_p3p_preferences.domain_prefs[domain]= (P3PPreferences::site_allow_cookies)lvi.lParam;
			}
		}
		g_p3p_preferences.CookieSave(g_dllpath+COOKIE_FILE);
		SendCommandToAllP3Ps(ID_CHANGED_COOKIE_SETTINGS);
	}

	EndDialog(IDOK);
	return 1;
}

LRESULT COverrideSitesDialog::OnCancel(WORD, WORD, HWND, BOOL&)
{
	EndDialog(IDCANCEL);
	return 1;

}

void COverrideSitesDialog::EnableButtons(int enable)
{
	if( enable )
	{
		::EnableWindow(GetDlgItem(ID_DELETE), TRUE);
	}
	else
	{
		::EnableWindow(GetDlgItem(ID_DELETE), FALSE);
	}
}

