#ifndef __URLListDLG_H_
#define __URLListDLG_H_

#include "resource.h"       // main symbols
#include <atlhost.h>
#include "P3PMatchInfo.h"


/////////////////////////////////////////////////////////////////////////////
// CURLListDialog dialog

class CURLListDialog : public CAxDialogImpl<CURLListDialog>
{
	GList<GURL> &url_list;
	GString window_title;
	GString static_text;
// Construction
public:
	// constructors
	CURLListDialog(GList<GURL> &u_list);   
	CURLListDialog(GList<GURL> &u_list, GString window_title, GString text);

	// destructor
	~CURLListDialog();

	enum { IDD = IDD_DISPLAY_URLLIST };

BEGIN_MSG_MAP(CURLListDialog)
	MESSAGE_HANDLER(WM_INITDIALOG, OnInitDialog)
	MESSAGE_HANDLER(WM_DESTROY, OnDestroy)
	MESSAGE_HANDLER(WM_HELP, OnContextHelp)
	MESSAGE_HANDLER(WM_NOTIFY, OnNotify )
	COMMAND_ID_HANDLER(IDOK, OnOK)
	COMMAND_ID_HANDLER(ID_DELETE, OnDelete)
	COMMAND_ID_HANDLER(IDCANCEL, OnCancel)
	COMMAND_ID_HANDLER(IDC_NOPROMPT_ALLFORMS, OnNoPromptAllForms)
END_MSG_MAP()

	LRESULT OnInitDialog(UINT, WPARAM, LPARAM, BOOL&);
	LRESULT OnDestroy(UINT, WPARAM, LPARAM, BOOL&);
	LRESULT OnOK(WORD, WORD, HWND, BOOL&);
	LRESULT OnContextHelp(UINT, WPARAM, LPARAM, BOOL&);
	LRESULT OnNotify(UINT, WPARAM, LPARAM, BOOL&);
	LRESULT OnDelete(WORD, WORD, HWND, BOOL&);
	LRESULT OnCancel(WORD, WORD, HWND, BOOL&);
	LRESULT OnNoPromptAllForms(WORD, WORD, HWND, BOOL&);
private:
	void EnableButtons(int enable);
	int GetSelectedItemLParam();
	
};


#endif 