// WebHost.h : Declaration of the CWebHost

#ifndef __WEBHOST_H_
#define __WEBHOST_H_

#include "resource.h"       // main symbols
#include <atlctl.h>
#include <atlhost.h>
#include "P3PEvaluator.h"

#define MARGIN 2


/////////////////////////////////////////////////////////////////////////////
// CWebHost
class ATL_NO_VTABLE CWebHost : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public IDispatchImpl<IWebHost, &IID_IWebHost, &LIBID_P3PClientLib>,
	public IDispatchImpl<IWebHostUI, &IID_IWebHostUI, &LIBID_P3PClientLib>,
	public CComControl<CWebHost>,
	public IPersistStreamInitImpl<CWebHost>,
	public IOleControlImpl<CWebHost>,
	public IOleObjectImpl<CWebHost>,
	public IOleInPlaceActiveObjectImpl<CWebHost>,
	public IViewObjectExImpl<CWebHost>,
	public IOleInPlaceObjectWindowlessImpl<CWebHost>,
	public IPersistStorageImpl<CWebHost>,
	public ISpecifyPropertyPagesImpl<CWebHost>,
	public IQuickActivateImpl<CWebHost>,
	public IDataObjectImpl<CWebHost>,
	public IProvideClassInfo2Impl<&CLSID_WebHost, NULL, &LIBID_P3PClientLib>,
	public CComCoClass<CWebHost, &CLSID_WebHost>
{
public:
	CWebHost()
	{
		m_bWindowOnly = TRUE;
	}

	~CWebHost();

DECLARE_REGISTRY_RESOURCEID(IDR_WEBHOST)

DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(CWebHost)
	COM_INTERFACE_ENTRY(IWebHost)
	COM_INTERFACE_ENTRY(IWebHostUI)
	COM_INTERFACE_ENTRY2(IDispatch, IWebHost)
	COM_INTERFACE_ENTRY(IViewObjectEx)
	COM_INTERFACE_ENTRY(IViewObject2)
	COM_INTERFACE_ENTRY(IViewObject)
	COM_INTERFACE_ENTRY(IOleInPlaceObjectWindowless)
	COM_INTERFACE_ENTRY(IOleInPlaceObject)
	COM_INTERFACE_ENTRY2(IOleWindow, IOleInPlaceObjectWindowless)
	COM_INTERFACE_ENTRY(IOleInPlaceActiveObject)
	COM_INTERFACE_ENTRY(IOleControl)
	COM_INTERFACE_ENTRY(IOleObject)
	COM_INTERFACE_ENTRY(IPersistStreamInit)
	COM_INTERFACE_ENTRY2(IPersist, IPersistStreamInit)
	COM_INTERFACE_ENTRY(ISpecifyPropertyPages)
	COM_INTERFACE_ENTRY(IQuickActivate)
	COM_INTERFACE_ENTRY(IPersistStorage)
	COM_INTERFACE_ENTRY(IDataObject)
	COM_INTERFACE_ENTRY(IProvideClassInfo)
	COM_INTERFACE_ENTRY(IProvideClassInfo2)
END_COM_MAP()

BEGIN_PROP_MAP(CWebHost)
	PROP_DATA_ENTRY("_cx", m_sizeExtent.cx, VT_UI4)
	PROP_DATA_ENTRY("_cy", m_sizeExtent.cy, VT_UI4)
	// Example entries
	// PROP_ENTRY("Property Description", dispid, clsid)
	// PROP_PAGE(CLSID_StockColorPage)
END_PROP_MAP()

BEGIN_MSG_MAP(CWebHost)
	MESSAGE_HANDLER(WM_CREATE, OnCreate)
	CHAIN_MSG_MAP(CComControl<CWebHost>)
END_MSG_MAP()
// Handler prototypes:
//  LRESULT MessageHandler(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
//  LRESULT CommandHandler(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled);
//  LRESULT NotifyHandler(int idCtrl, LPNMHDR pnmh, BOOL& bHandled);



// IViewObjectEx
	DECLARE_VIEW_STATUS(0)

// IWebHost
public:

// IWebHostUI
public:
	// Example method called by the HTML to change the <BODY> background color
	STDMETHOD(OnClick)(IDispatch* pdispBody, VARIANT varColor)
	{
		CComQIPtr<IHTMLBodyElement> spBody(pdispBody);
		if (spBody != NULL)
			spBody->put_bgColor(varColor);
		return S_OK;
	}

	LRESULT OnCreate(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/);
	STDMETHODIMP Run(HWND parent, const char *content);
	STDMETHODIMP Run(HWND parent, Result &result);
	

	CComPtr<IWebBrowser2> m_spBrowser;

private:
	GString summaryfilename;
};

#endif //__WEBHOST_H_
