#ifndef __XML_FILE_H__
#define __XML_FILE_H__
#include "GString.h"
#include "GContainer.h"
#include <stdio.h>


class XmlOutNode;
class XmlOutFile
{
friend XmlOutNode;

private:
	GString filename;
	FILE *fp;
	int depth;
	
	
public:
	XmlOutFile(GString path);
	~XmlOutFile();
	

};

class XmlOutNode
{
	XmlOutFile &file;
	GString name;
	bool empty;
	bool add_newline;
	bool add_depth;
public:
	XmlOutNode(XmlOutFile &_file, bool is_empty=false, bool add_new_lines=true, bool depth=true):file(_file), empty(is_empty), add_newline(add_new_lines), add_depth(depth)
	{
		file.depth++;
	};
	~XmlOutNode();
    void setNodeName(GString name, GList<GString> &att, GList<GString> &val);
	void setNodeName(GString name, GMap<GString, GString> &attrvalues);
	void setNodeName(GString name);

	// writes unformatted text data ending with new line 
	void println(const char* string);
	// writes unformatted text data 
	void print(const char* string);
	// addes a comment
	void add_comment(const char * comment);
};



#endif